#include "DBHelpMySQL.h"

int main(int argc, char **argv)
{


	char buf[MAXLINE];
	float  float_data;
	char str_data[DEFAULT_FIELD_SIZE];
	MYSQL_RES * result;
	MYSQL_ROW row;
	MYSQL_STMT * s;
	MYSQL *conn;
	DBHelpMySQL db;


	printf("从配置文件读:\n用户名:%s	密码:%s\n服务器:%s	端口:%s \n当前数据库:%s \n",
			db.User(), db.Pwd(), db.Server(), db.Port(), db.DataBaseName());
	printf("--------------------------------\n");


	printf("SelectDB()函数测试\n");
	if(db.SelectDB("refactoring"))
		printf("改变数据库成功! 当前数据库:%s\n", db.DataBaseName());
	else
		printf("改变数据库失败!\n");
	printf("--------------------------------\n");

	db.GetHostInfo(buf);
	printf("GetHostInfo()函数测试\n");
	printf("服务器信息:%s\n", buf);
	printf("--------------------------------\n");
	db.GetServerVerion(buf);
	printf("GetServerVersion()函数测试\n");
	printf("服务器版本号:%s\n", buf);
	printf("--------------------------------\n");
	printf("GetProtocolInfo()函数测试\n");
	printf("协议号: %u\n", db.GetProtocolInfo());
	printf("--------------------------------\n");
	db.GetState(buf);
	printf("GetState()函数测试\n");
	printf("数据库信息:%s\n", buf);


	printf("--------------------------------\n");
	printf("Query()函数测试\n");
	result = db.Query("SELECT  *  FROM currencies LIMIT 0, 6");
	printf("GetRowCount() GetColumnCount()测试\n");
	printf("行数:%lu\n", (unsigned long)db.GetRowCount(result));
	printf("列数:%lu\n", (unsigned long)db.GetColumnCount(result));
	printf("GetNextRecord() GetFieldInfoOfIndex()测试\n");
	printf("%s\t%s\n", db.GetFieldInfoOfIndex(result, 0)->name, db.GetFieldInfoOfIndex(result, 1)->name);
	while((row = db.GetNextRecord(result)))
		printf("%s\t%s\n", row[0], row[1]);
	db.FreeResult(result);
	db.FreeConn();


	printf("--------------------------------\n");
	printf("ExecuteNonQuery()函数测试\n");
	int rowaffected = db.ExecuteNonQuery("INSERT INTO currency_weight values('CDF', 1.0)", NULL, 0);
	printf("INSERT 语句影响的行数: %d\n", rowaffected);


	MYSQL_BIND params[2];
	memset(params, 0, sizeof(params));
	strcpy(str_data, "CDF");
	float_data = 2.0f;
	params[0].buffer = &float_data;
	params[0].buffer_type = MYSQL_TYPE_FLOAT;
	params[1].buffer = str_data;
	params[1].buffer_type = MYSQL_TYPE_VARCHAR;
	params[1].buffer_length = strlen(str_data);
	rowaffected = db.ExecuteNonQuery("UPDATE currency_weight SET weight = ? WHERE iso = ?", params, 2);
	printf("UPDATE 语句影响的行数: %d\n", rowaffected);
	memset(params, 0, sizeof(params));



	printf("--------------------------------\n");
	printf("SetAutoCommit() StartTransaction() RollBackTransaction() ExecuteSQL() CommitTransaction()函数测试\n");
	db.SetAutoCommit(false);
	printf("执行DELETE FROM currency_weight WHERE iso = 'CDF'\n");
	db.StartTransaction();
	db.Query("DELETE FROM currency_weight WHERE iso = 'CDF'");
	db.RollBackTransaction();
	printf("执行UPDATE currency_weight SET weight = 3.0 WHERE iso = 'CDF'\n");
	db.ExecuteSQL("UPDATE currency_weight SET weight = 3.0 WHERE iso = 'CDF'");
	db.CommitTransaction();
	db.FreeConn();


	printf("--------------------------------\n");
	printf("ExecuteReader()函数测试\n");
	float* res = (float *) db.ExecuteScalar("SELECT weight FROM currency_weight WHERE iso = 'CDF'", NULL, 0);
	printf("第一行第一列:%.2f\n", *(float *)res);
	db.Dispose();


	printf("--------------------------------\n");
	printf("ExecuteReader() SeekRecord()函数测试\n");
	s = db.ExecuteReader("SELECT  *  FROM currencies LIMIT 0, 6", NULL, 0);

	int rc = db.GetRowCount(s);
	int i = 1;
	DATAROW dr = db.GetNextRecord(s);
	printf("%s\t%s\n", dr.columnNames[0], dr.columnNames[1]);
	do
	{
		printf("%s\t%s\n", (char *)dr.dataArea[0], (char *)dr.dataArea[1]);
		dr = db.GetNextRecord(s);
		if(i%2 == 0)
			db.SeekRecord(s, 0);
	} while (i++ < rc);
	db.FreeStmt(s);
	db.Dispose();


	printf("--------------------------------\n");
	printf("MultQuery() GetAffectedCount() GetNextResultSet()函数测试\n");
	conn = db.MultQuery("SELECT * FROM currency_weight;\
						 DELETE FROM currency_weight WHERE iso = 'CDF';\
						 SELECT * FROM thresholds;");
	do
	{
		result = db.GetResultSet(conn);
		printf("影响的行数:%lu\n", (unsigned long)db.GetAffectedCount(conn));
		if (result != NULL)
		{
			printf("%s\t%s\n", (char *)result->fields[0].name, (char *)result->fields[1].name);
			while ((row = db.GetNextRecord(result)))
				printf("%s\t%s\n", row[0], row[1]);
			db.FreeResult(result);
		}
		printf("----------------------------------\n");
	}
	while(db.GetNextResultSet(conn)==0);
	printf("IsConnected()函数测试\n");
	if(db.IsConnected())
	{
		db.FreeConn();
		printf("关闭连接成功\n");
	}


	printf("--------------------------------\n");
	printf("GetAutoID()函数测试\n");
	db.MultQuery("create table t1(id int primary key auto_increment, name varchar(5) not null);\
				 insert into t1(name) values('gw');\
				 insert into t1(name) values('lx');");
	printf("刚插入的ID是:%lu\n又执行一次插入操作\n", (unsigned long)db.GetAutoID());
	db.ExecuteSQL("insert into t1(name) values('lxm')");
	printf("刚插入的ID是:%lu\n", (unsigned long)db.GetAutoID());
	db.ExecuteSQL("drop table t1");
	db.FreeConn();

	//db.ShutDown()?printf("关闭服务成功"):printf("关闭服务失败");

	getchar();
	return 0;
}
